using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;

namespace CheckboxinHeader
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        DataTable dt = new DataTable();

        private void Form1_Load(object sender, EventArgs e)
        {
            DataColumn dc1 = new DataColumn("OperationName", typeof(string));
            this.dt.Columns.Add(dc1);
            DataColumn dc2 = new DataColumn("ObjectType", typeof(string));
            this.dt.Columns.Add(dc2);
            DataColumn dc3 = new DataColumn("Status", typeof(bool));
            this.dt.Columns.Add(dc3);


            FillDataTable();
            this.segPermissions.DataSource = this.dt;
            this.segPermissions.ShowGroupDropArea = true;
            this.segPermissions.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(segPermissions_QueryCellStyleInfo);

            this.segPermissions.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(segPermissions_SaveCellText);
            this.segPermissions.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(segPermissions_TableControlCellClick);
            this.segPermissions.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp);
            this.segPermissions.TableControlCheckBoxClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(segPermissions_TableControlCheckBoxClick);

            
        }

        #region Datasource
        private void FillDataTable()
        {
            DataRow dr1 = this.dt.NewRow();
            dr1[0] = "Fileds";
            dr1[1] = "Add";
            dr1[2] = true;
            this.dt.Rows.Add(dr1);

            DataRow dr2 = this.dt.NewRow();
            dr2[0] = "Fileds";
            dr2[1] = "Remove";
            dr2[2] = false;
            this.dt.Rows.Add(dr2);

            DataRow dr5 = this.dt.NewRow();
            dr5[0] = "Fileds";
            dr5[1] = "Delete";
            dr5[2] = false;
            this.dt.Rows.Add(dr5);

            DataRow dr3 = this.dt.NewRow();
            dr3[0] = "FiledSet";
            dr3[1] = "Add";
            dr3[2] = false;
            this.dt.Rows.Add(dr3);

            DataRow dr4 = this.dt.NewRow();
            dr4[0] = "FiledSet";
            dr4[1] = "Delete";
            dr4[2] = false;
            this.dt.Rows.Add(dr4);

            DataRow dr6 = this.dt.NewRow();
            dr6[0] = "FiledSet";
            dr6[1] = "Rename";
            dr6[2] = true;
            this.dt.Rows.Add(dr6);

            DataRow dr7 = this.dt.NewRow();
            dr7[0] = "CompositFields";
            dr7[1] = "Add";
            dr7[2] = false;
            this.dt.Rows.Add(dr7);

            DataRow dr8 = this.dt.NewRow();
            dr8[0] = "CompositFields";
            dr8[1] = "Delete";
            dr8[2] = true;
            this.dt.Rows.Add(dr8);

            DataRow dr9 = this.dt.NewRow();
            dr9[0] = "CompositFields";
            dr9[1] = "Rename";
            dr9[2] = false;
            this.dt.Rows.Add(dr9);
        }

        #endregion

        #region Grid Functions
       
        System.Collections.Hashtable CheckBoxValues = new System.Collections.Hashtable();
        int rowIndex = 0;
     
        void segPermissions_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
        {
            try
            {
                if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell
                    && e.TableCellIdentity.Column.Name == "Status")
                {
                    e.Style.CellType = "CheckBox";
                    e.Style.ReadOnly = false;
                    e.Style.CellAppearance = GridCellAppearance.Raised;
                    string cname = e.TableCellIdentity.Column.Name;
                    string gname = e.TableCellIdentity.DisplayElement.ParentGroup.Name;
                    string cename = Convert.ToString(e.TableCellIdentity.DisplayElement.ParentGroup.Category);
                    bool CheckBoxValue = true;
                    string Keys = string.Format("{0}_{1}_{2}", cname, gname, cename);
                    if (CheckBoxValues.Contains(string.Format("{0}_{1}_{2}", cname, gname, cename)))
                    {
                        CheckBoxValue = Convert.ToBoolean(CheckBoxValues[Keys]);
                    }
                    else
                    {
                        CheckBoxValues.Add(Keys, true);
                        CheckBoxValue = true;
                    }
                    e.Style.CellValue = CheckBoxValue;
                    e.Style.CellValueType = typeof(bool);
                    e.Style.Enabled = true;
                }
                e.Handled = true;
            }
            catch (Exception objException)
            {
                Console.WriteLine(objException.Message); 
            }
        }

        void segPermissions_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
        {
            try
            {
                GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
                if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
                {
                    string cname = style.TableCellIdentity.Column.Name;
                    string gname = style.TableCellIdentity.DisplayElement.ParentGroup.Name  ;
                    string cename = Convert.ToString( style.TableCellIdentity.DisplayElement.ParentGroup.Category) ;
                    CheckBoxValues[string.Format("{0}_{1}_{2}", cname,gname,cename) ] = bool.Parse(e.Text);
                    e.Handled = true;
                }
            }
            catch (Exception objException)
            {
               
            }
        }

        void segPermissions_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
        {
            this.rowIndex = e.Inner.RowIndex;
            GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex];
            if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && style.TableCellIdentity.Column.Name == "Check")
            {
                e.Inner.Cancel = true;
            }
        }

        bool isCheckBoxClickFired = false;

        void TableControl_MouseUp(object sender, MouseEventArgs e)
        {
            int row, col;
            
            this.segPermissions.TableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
            this.rowIndex = row;

            GridTableCellStyleInfo style = this.segPermissions.TableControl.Model[row, col];

            #region If you want to change the child settings then uncomment the below block.
            //if ( !isCheckBoxClickFired && style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell
            //    && style.TableCellIdentity.Column != null
            //    && style.TableCellIdentity.Column.Name == "Status")
            //{

            //    bool chk = (bool)style.CellValue;

            //    this.rowIndex = row;
            //    this.clickCounter = -1;
            //    Element el = style.TableCellIdentity.DisplayElement;
            //    foreach (Record rec in el.ParentGroup.Records)
            //    {
            //        rec.SetValue("Status", chk);
            //    }
            //}
            #endregion

            IMouseController controller;
            this.segPermissions.TableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

            if (controller.Name == "DragGroupHeader")
            {
                this.segPermissions.TableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
            }
            isCheckBoxClickFired = false;
        }

        void segPermissions_TableControlCheckBoxClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
        {
            #region If you want to change the child settings then uncomment the below block.
            //try
            //{
            //    isCheckBoxClickFired = true;
            //    GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            //    if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
            //    {

            //        bool chk = (bool)this.segPermissions.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue;
            //        e.TableControl.BeginUpdate();

            //        this.rowIndex = e.Inner.RowIndex;
            //        this.clickCounter = -1;
            //        int row = e.Inner.RowIndex;
            //        int col = e.Inner.ColIndex;
            //        Element el = style.TableCellIdentity.DisplayElement;
            //        foreach (Record rec in el.ParentGroup.Records)
            //        {

            //            rec.SetValue("Status", !chk);
            //        }
            //        e.TableControl.EndUpdate(true);
            //    }
            //}
            //catch (Exception objException)
            //{

            //}
            #endregion
        } 
        #endregion

       
    }
}